<img src="documentation/logo.png" width="862" height="111" alt="logo">

[![Build Status](https://travis-ci.org/Originate/exosphere.svg?branch=master)](https://travis-ci.org/Originate/exosphere)

> _ex·o·sphere (ˈeksōˌsfir) - the outermost region of a planet's atmosphere (aka, above the clouds)_

__Exosphere makes micro-services easy and fun__

Exosphere is a high-level framework
for building, testing, deploying, and operating
a wide variety of micro-service application ecosystems
with unparalleled devops productivity and joy.

- scaffold, run, test, deploy, operate, and evolve fleets of polyglot micro-services
  without boilerplate code and process
- develop against explicit
  functional, performance, security, and reliability requirements<sup>&#42;</sup>
- data-center aware, runs on top of public and private cloud environments
  like [AWS](https://aws.amazon.com),
  [Google Cloud](https://cloud.google.com),
  [Azure](https://azure.microsoft.com),
  [DCOS](https://dcos.io), etc<sup>&#42;</sup>
- marketplace for reusable services<sup>&#42;</sup>


__Get Started:__
* [install the SDK](website/tutorial/part_1/03_installation.md)
* [download and run an example application](website/example-apps.md)
* build your own application by following the [tutorial](website/tutorial)


__Reference:__
* the [scaffolding commands](website/scaffolding.md)
* [platform developer documentation](website/developers/developers.md)


__Further Reading:__
* related projects: [LeverOS](https://github.com/leveros/leveros)


<hr>

<sup>&#42;</sup>
coming soon
