// Generated by LiveScript 1.5.0
var abbrev, red, add, clone, create, deploy, lint, run, setup, sync, test, fs, map, pkg, path, updateNotifier, commands, commandName, fullCommandName;
abbrev = require('abbrev');
red = require('chalk').red;
add = require('../../exo-add');
clone = require('../../exo-clone');
create = require('../../exo-create');
deploy = require('../../exo-deploy');
lint = require('../../exo-lint');
run = require('../../exo-run');
setup = require('../../exo-setup');
sync = require('../../exo-sync');
test = require('../../exo-test');
fs = require('fs');
map = require('prelude-ls').map;
pkg = require('../package.json');
path = require('path');
updateNotifier = require('update-notifier');
updateNotifier({
  pkg: pkg
}).notify();
commands = {
  add: add,
  clone: clone,
  create: create,
  deploy: deploy,
  lint: lint,
  run: run,
  setup: setup,
  sync: sync,
  test: test
};
commandName = process.argv[2];
fullCommandName = completeCommandName(commandName);
if (commandName === 'version') {
  console.log("Exosphere version " + pkg.version);
} else if (!commandName) {
  missingCommand();
} else if (!fullCommandName) {
  unknownCommand(commandName);
} else {
  process.argv.shift();
  commands[fullCommandName]();
}
function completeCommandName(commandName){
  return abbrev(commandNames())[commandName];
}
function missingCommand(){
  console.log(red("Error: missing command\n"));
  return printUsage();
}
function unknownCommand(command){
  console.log(red("Error: unknown command '" + command + "'\n"));
  return printUsage();
}
function printUsage(){
  var i$, ref$, len$, command;
  console.log('Usage: exo <command> [options]\n');
  console.log('Available commands are:');
  for (i$ = 0, len$ = (ref$ = commandNames()).length; i$ < len$; ++i$) {
    command = ref$[i$];
    if (command === 'add') {
      console.log("* add [<service-role>] [<template-name>] [<model-name>] [<description>]");
    } else {
      console.log("* " + command);
    }
  }
  return console.log();
}
function commandNames(){
  return Object.keys(commands);
}