// Generated by LiveScript 1.5.0
var ref$, red, green, EventEmitter, fs, ObservableProcess, path, ServiceCloner;
ref$ = require('chalk'), red = ref$.red, green = ref$.green;
EventEmitter = require('events');
fs = require('fs');
ObservableProcess = require('observable-process');
path = require('path');
ServiceCloner = (function(superclass){
  var prototype = extend$((import$(ServiceCloner, superclass).displayName = 'ServiceCloner', ServiceCloner), superclass).prototype, constructor = ServiceCloner;
  function ServiceCloner(arg$){
    this.role = arg$.role, this.config = arg$.config, this.logger = arg$.logger;
    this.write = bind$(this, 'write', prototype);
    this.start = bind$(this, 'start', prototype);
  }
  ServiceCloner.prototype.start = function(done){
    var x$, this$ = this;
    x$ = new ObservableProcess(this._createCommand('git clone'), {
      cwd: this.config.root,
      stdout: {
        write: this.write
      },
      stderr: {
        write: this.write
      }
    });
    x$.on('ended', function(exitCode){
      switch (false) {
      case !(exitCode > 0):
        this$.logger.log({
          role: this$.role,
          text: red("Service cloning failed")
        });
        break;
      case !!this$._isValidService():
        this$.logger.log({
          role: this$.role,
          text: red(this$.role + " is an invalid service"),
          exitCode: exitCode != null ? exitCode : 1
        });
        break;
      default:
        this$.logger.log({
          role: this$.role,
          text: green("done")
        });
      }
      return done(null, exitCode);
    });
    return x$;
  };
  ServiceCloner.prototype._isValidService = function(){
    var e;
    try {
      fs.accessSync(path.join(this.config.path, 'service.yml'));
      return true;
    } catch (e$) {
      e = e$;
      return false;
    }
  };
  ServiceCloner.prototype._createCommand = function(command){
    return [command, this.config.origin, this.config.path].join(' ');
  };
  ServiceCloner.prototype.write = function(text){
    return this.logger.log({
      role: this.role,
      text: text.trim().replace(/\.*$/, '')
    });
  };
  return ServiceCloner;
}(EventEmitter));
module.exports = ServiceCloner;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}