// Generated by LiveScript 1.5.0
var green, templatesPath, inquirer, fs, yaml, merge, N, path, empty, tmplconv, yamlCutter, service, slice$ = [].slice;
green = require('chalk').green;
templatesPath = require('../../../exosphere-shared').templatesPath;
inquirer = require('inquirer');
fs = require('fs');
yaml = require('js-yaml');
merge = require('merge');
N = require('nitroglycerin');
path = require('path');
empty = require('prelude-ls').empty;
tmplconv = require('tmplconv');
yamlCutter = require('yaml-cutter');
service = function(){
  var ref$, data, questions;
  console.log('We are about to create a new Exosphere service!\n');
  ref$ = parseCommandLine(process.argv), data = ref$.data, questions = ref$.questions;
  return inquirer.prompt(questions).then(function(answers){
    var srcPath, targetPath, appConfig, error;
    data = merge(data, answers);
    srcPath = path.join(templatesPath, 'add-service', data.templateName);
    targetPath = path.join(process.cwd(), '..', data.serviceRole);
    try {
      appConfig = yaml.safeLoad(fs.readFileSync('application.yml', 'utf8'));
    } catch (e$) {
      error = e$;
      throw new Error("Creation of service '" + data.serviceRole + "' has failed.");
    }
    data.appName = appConfig.name;
    return tmplconv.render(srcPath, targetPath, {
      data: data
    }).then(function(){
      var options;
      options = {
        file: 'application.yml',
        root: 'services.public',
        key: data.serviceRole,
        value: {
          location: "../" + data.serviceRole
        }
      };
      return yamlCutter.insertHash(options, N(function(){
        return console.log(green("\ndone"));
      }));
    });
  });
};
function serviceRoles(){
  return fs.readdirSync(path.join(templatesPath, 'add-service'));
}
function parseCommandLine(commandLineArgs){
  var data, questions, _, serviceRole, author, templateName, modelName, description;
  data = {};
  questions = [];
  _ = commandLineArgs[0], _ = commandLineArgs[1], _ = commandLineArgs[2], serviceRole = commandLineArgs[3], author = commandLineArgs[4], templateName = commandLineArgs[5], modelName = commandLineArgs[6], description = slice$.call(commandLineArgs, 7);
  if (serviceRole) {
    data.serviceRole = serviceRole;
  } else {
    questions.push({
      message: 'Name of the service to create',
      type: 'input',
      name: 'serviceRole',
      filter: function(input){
        return input.trim();
      },
      validate: function(input){
        return input.length > 0;
      }
    });
  }
  if (templateName) {
    data.templateName = templateName;
  } else {
    questions.push({
      message: 'Type:',
      type: 'list',
      name: 'templateName',
      choices: serviceRoles()
    });
  }
  if (modelName) {
    data.modelName = modelName;
  } else {
    questions.push({
      message: 'Name of the data model (leave blank if no model exists):',
      type: 'input',
      name: 'modelName',
      filter: function(input){
        return input.trim();
      }
    });
  }
  if (!empty(description)) {
    data.description = description.join(' ');
  } else {
    questions.push({
      message: 'Description:',
      type: 'input',
      name: 'description',
      filter: function(input){
        return input.trim();
      }
    });
  }
  if (author) {
    data.author = author;
  } else {
    questions.push({
      message: 'Author:',
      type: 'input',
      name: 'author',
      filter: function(input){
        return input.trim();
      },
      validator: function(input){
        return input.length > 0;
      }
    });
  }
  return {
    data: data,
    questions: questions
  };
}
module.exports = service;