// Generated by LiveScript 1.5.0
var ref$, cyan, green, Docker, Logger, fs, inquirer, yaml, path;
ref$ = require('chalk'), cyan = ref$.cyan, green = ref$.green;
Docker = require('./docker-runner');
Logger = require('../../exosphere-shared').Logger;
fs = require('fs');
inquirer = require('inquirer');
yaml = require('js-yaml');
path = require('path');
module.exports = function(){
  var commandFlag, appConfig, logger, docker, action, question, x$, this$ = this;
  commandFlag = process.argv[2];
  appConfig = yaml.safeLoad(fs.readFileSync(path.join(process.cwd(), 'application.yml'), 'utf8'));
  logger = new Logger;
  docker = new Docker(appConfig, logger);
  if (commandFlag === '--nuke' || commandFlag === '--teardown') {
    action = (function(){
      switch (commandFlag) {
      case '--nuke':
        return 'completely remove all parts of';
      case '--teardown':
        return 'teardown';
      }
    }());
    console.log("You are about to " + action + " " + green(appConfig.name) + " " + cyan(appConfig.version) + "\n");
    question = {
      type: 'list',
      name: 'continue',
      message: 'Are you sure?',
      choices: ['yes', 'no']
    };
    return inquirer.prompt([question]).then(function(answer){
      if (answer['continue'] === 'no') {
        return process.exit(2);
      } else {
        return docker.start(commandFlag);
      }
    });
  } else {
    console.log("Deploying " + green(appConfig.name) + " " + cyan(appConfig.version) + "\n");
    x$ = docker;
    x$.dockerhubPush(function(err){
      switch (false) {
      case !err:
        return logger.log({
          role: 'exo-deploy',
          text: err.message
        });
      }
      return x$.start();
    });
    return x$;
  }
};