// Generated by LiveScript 1.5.0
var async, child_process, dashify, DockerHelper, fs, yaml, ObservableProcess, path, DockerHub;
async = require('async');
child_process = require('child_process');
dashify = require('dashify');
DockerHelper = require('../../exosphere-shared').DockerHelper;
fs = require('fs');
yaml = require('js-yaml');
ObservableProcess = require('observable-process');
path = require('path');
DockerHub = (function(){
  DockerHub.displayName = 'DockerHub';
  var prototype = DockerHub.prototype, constructor = DockerHub;
  function DockerHub(appConfig, logger){
    this.appConfig = appConfig;
    this.logger = logger;
    this.write = bind$(this, 'write', prototype);
    this._pushImage = bind$(this, '_pushImage', prototype);
  }
  DockerHub.prototype.push = function(done){
    var images, i$, len$, image, this$ = this;
    images = this._imageNames();
    for (i$ = 0, len$ = images.length; i$ < len$; ++i$) {
      image = images[i$];
      if (!DockerHelper.imageExists(image)) {
        return done(new Error("No Docker image exists for service '" + image.name + "'. Please run exo-setup."));
      }
    }
    return async.eachSeries(images, function(){
      return this$._pushImage(arguments[0], arguments[1]);
    }, done);
  };
  DockerHub.prototype._pushImage = function(image, done){
    var x$, this$ = this;
    this.logger.log({
      role: 'exo-deploy',
      text: "pushing " + image.name + " to DockerHub..."
    });
    x$ = new ObservableProcess("docker push " + image.author + "/" + image.name, {
      stdout: {
        write: this.write
      },
      stderr: {
        write: this.write
      }
    });
    x$.on('ended', function(exitCode){
      switch (false) {
      case !exitCode:
        return done(new Error(image.name + " could not be pushed to DockerHub"));
      }
      this$.logger.log({
        role: 'exo-deploy',
        text: image.name + " pushed to DockerHub"
      });
      return done();
    });
    return x$;
  };
  DockerHub.prototype._imageNames = function(){
    var names, serviceType, name, ref$, config, serviceConfig;
    names = [];
    for (serviceType in this.appConfig.services) {
      for (name in ref$ = this.appConfig.services[serviceType]) {
        config = ref$[name];
        serviceConfig = yaml.safeLoad(fs.readFileSync(path.join(process.cwd(), config.location, 'service.yml'), 'utf8'));
        names.push({
          author: serviceConfig.author,
          name: dashify(serviceConfig.type)
        });
      }
    }
    return names;
  };
  DockerHub.prototype.write = function(text){
    return this.logger.log({
      role: 'exo-deploy',
      text: text,
      trim: false
    });
  };
  return DockerHub;
}());
module.exports = DockerHub;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}