// Generated by LiveScript 1.5.0
var DockerHub, DockerHelper, fs, yaml, ObservableProcess, path, Docker;
DockerHub = require('./docker-hub');
DockerHelper = require('../../exosphere-shared').DockerHelper;
fs = require('fs');
yaml = require('js-yaml');
ObservableProcess = require('observable-process');
path = require('path');
Docker = (function(){
  Docker.displayName = 'Docker';
  var prototype = Docker.prototype, constructor = Docker;
  function Docker(appConfig, logger){
    var this$ = this;
    this.appConfig = appConfig;
    this.logger = logger;
    this.write = bind$(this, 'write', prototype);
    this._run = bind$(this, '_run', prototype);
    process.env.AWS_ACCESS_KEY_ID == null && (function(){
      throw new Error("AWS_ACCESS_KEY_ID not provided");
    }());
    process.env.AWS_SECRET_ACCESS_KEY == null && (function(){
      throw new Error("AWS_SECRET_ACCESS_KEY not provided");
    }());
    this.version = function(it){
      return it.version;
    }(
    yaml.safeLoad(fs.readFileSync(path.join(__dirname, '../package.json'), 'utf8')));
  }
  Docker.prototype.dockerhubPush = function(done){
    var x$;
    x$ = new DockerHub(this.appConfig, this.logger);
    x$.push(function(err){
      return done(err);
    });
    return x$;
  };
  Docker.prototype.start = function(commandFlag){
    var image, x$, this$ = this;
    image = {
      author: 'originate',
      name: 'exo-deploy',
      version: this.version
    };
    if (DockerHelper.imageExists(image)) {
      return this._run(commandFlag);
    } else {
      this.logger.log({
        role: 'exo-deploy',
        text: "pulling ExoDeploy image version " + this.version
      });
      x$ = new ObservableProcess(DockerHelper.getPullCommand(image, {
        stdout: {
          write: this.write
        },
        stderr: {
          write: this.write
        }
      }));
      x$.on('ended', function(exitCode){
        switch (false) {
        case !exitCode:
          return new Error("docker image originate/exo-deploy could not be pulled");
        }
        return this$._run(commandFlag);
      });
      return x$;
    }
  };
  Docker.prototype._run = function(commandFlag){
    var flags, x$, this$ = this;
    flags = ("-v " + process.cwd() + ":/var/app:ro ") + ("--env AWS_ACCESS_KEY_ID=" + process.env.AWS_ACCESS_KEY_ID + " ") + ("--env AWS_SECRET_ACCESS_KEY=" + process.env.AWS_SECRET_ACCESS_KEY + " ");
    if (process.env.MONGODB_USER) {
      flags += "--env MONGODB_USER=" + process.env.MONGODB_USER + " ";
    }
    if (process.env.MONGODB_PW) {
      flags += "--env MONGODB_PW=" + process.env.MONGODB_PW;
    }
    x$ = new ObservableProcess("docker run " + flags + " originate/exo-deploy:" + this.version + " " + commandFlag, {
      stdout: {
        write: this.write
      },
      stderr: {
        write: this.write
      }
    });
    x$.on('ended', function(exitCode){
      switch (false) {
      case !exitCode:
        return new Error("docker image originate/exo-deploy could not be run");
      }
    });
    return x$;
  };
  Docker.prototype.write = function(text){
    return this.logger.log({
      role: 'exo-deploy',
      text: text,
      trim: false
    });
  };
  return Docker;
}());
module.exports = Docker;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}