// Generated by LiveScript 1.5.0
var ObservableProcess, path, Terraform;
ObservableProcess = require('observable-process');
path = require('path');
Terraform = (function(){
  Terraform.displayName = 'Terraform';
  var prototype = Terraform.prototype, constructor = Terraform;
  Terraform.prototype.get = function(done){
    var x$;
    x$ = new ObservableProcess("terraform get", {
      cwd: '/usr/src/terraform'
    });
    x$.on('ended', function(exitCode){
      switch (false) {
      case !exitCode:
        return done(new Error("terraform get failed: " + exitCode));
      }
      return done();
    });
    return x$;
  };
  Terraform.prototype.pullRemoteState = function(arg$, done){
    var backend, backendConfig, options, i$, len$, config, x$;
    backend = arg$.backend, backendConfig = arg$.backendConfig;
    options = "-backend=" + backend + " ";
    for (i$ = 0, len$ = backendConfig.length; i$ < len$; ++i$) {
      config = backendConfig[i$];
      options += "-backend-config=" + config + " ";
    }
    x$ = new ObservableProcess("terraform remote config " + options, {
      cwd: '/usr/src/terraform'
    });
    x$.on('ended', function(exitCode){
      switch (false) {
      case !exitCode:
        return done(new Error("terraform remote config failed: " + exitCode));
      }
      return done();
    });
    return x$;
  };
  Terraform.prototype.apply = function(arg$, done){
    var hostedZoneId, varFlags, x$;
    hostedZoneId = arg$.hostedZoneId;
    varFlags = hostedZoneId ? "-var 'hosted_zone_id=" + hostedZoneId + "'" : '';
    x$ = new ObservableProcess("terraform apply " + varFlags, {
      cwd: '/usr/src/terraform'
    });
    x$.on('ended', function(exitCode){
      switch (false) {
      case !exitCode:
        return done(new Error("terraform apply failed: " + exitCode));
      }
      return done();
    });
    return x$;
  };
  Terraform.prototype.destroy = function(done){
    var x$, this$ = this;
    x$ = new ObservableProcess("terraform destroy -force ", {
      cwd: '/usr/src/terraform'
    });
    x$.wait('Enter a value:', function(){
      return x$.enter('yes');
    });
    x$.on('ended', function(exitCode){
      switch (false) {
      case !exitCode:
        return done(new Error("terraform destroy failed: " + exitCode));
      }
      return done();
    });
    return x$;
  };
  function Terraform(){}
  return Terraform;
}());
module.exports = Terraform;