// Generated by LiveScript 1.5.0
var async, EventEmitter, fs, path, ref$, difference, find, filter, reject, each, yaml, AppLinter;
async = require('async');
EventEmitter = require('events').EventEmitter;
fs = require('fs');
path = require('path');
ref$ = require('prelude-ls'), difference = ref$.difference, find = ref$.find, filter = ref$.filter, reject = ref$.reject, each = ref$.each;
yaml = require('js-yaml');
AppLinter = (function(superclass){
  var prototype = extend$((import$(AppLinter, superclass).displayName = 'AppLinter', AppLinter), superclass).prototype, constructor = AppLinter;
  function AppLinter(arg$){
    this.appConfig = arg$.appConfig, this.logger = arg$.logger;
  }
  AppLinter.prototype.start = function(){
    var ref$, sentMessages, receivedMessages;
    ref$ = this.aggregateMessages(), sentMessages = ref$.sentMessages, receivedMessages = ref$.receivedMessages;
    return this.lintMessages(sentMessages, receivedMessages);
  };
  AppLinter.prototype.lintMessages = function(sent, received){
    var notReceived, notSent, i$, len$, msg, results$ = [];
    notReceived = difference(Object.keys(sent), Object.keys(received));
    notSent = difference(Object.keys(received), Object.keys(sent));
    if (notReceived.length === 0 && notSent.length === 0) {
      return this.logger.log({
        role: 'exo-lint',
        text: 'Lint passed'
      });
    }
    if (notReceived.length) {
      this.logger.log({
        role: 'exo lint',
        text: "The following messages are sent but not received:"
      });
      for (i$ = 0, len$ = notReceived.length; i$ < len$; ++i$) {
        msg = notReceived[i$];
        this.logger.log({
          role: sent[msg],
          text: msg
        });
      }
    }
    if (notSent.length) {
      this.logger.log({
        role: 'exo lint',
        text: "The following messages are received but not sent:"
      });
      for (i$ = 0, len$ = notSent.length; i$ < len$; ++i$) {
        msg = notSent[i$];
        results$.push(this.logger.log({
          role: received[msg],
          text: msg
        }));
      }
      return results$;
    }
  };
  AppLinter.prototype.aggregateMessages = function(){
    var sentMessages, receivedMessages, protectionLevel, serviceRole, ref$, serviceData, serviceConfig, i$, ref1$, len$, message;
    sentMessages = {};
    receivedMessages = {};
    for (protectionLevel in this.appConfig.services) {
      for (serviceRole in ref$ = this.appConfig.services[protectionLevel]) {
        serviceData = ref$[serviceRole];
        serviceConfig = this.getConfig(serviceData);
        for (i$ = 0, len$ = (ref1$ = serviceConfig.messages.sends || []).length; i$ < len$; ++i$) {
          message = ref1$[i$];
          (sentMessages[message] || (sentMessages[message] = [])).push(serviceRole);
        }
        for (i$ = 0, len$ = (ref1$ = serviceConfig.messages.receives || []).length; i$ < len$; ++i$) {
          message = ref1$[i$];
          (receivedMessages[message] || (receivedMessages[message] = [])).push(serviceRole);
        }
      }
    }
    return {
      sentMessages: sentMessages,
      receivedMessages: receivedMessages
    };
  };
  AppLinter.prototype.getConfig = function(serviceData){
    return yaml.safeLoad(fs.readFileSync(path.join(process.cwd(), serviceData.location, 'service.yml'), 'utf8'));
  };
  return AppLinter;
}(EventEmitter));
module.exports = AppLinter;
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}