// Generated by LiveScript 1.5.0
var async, red, child_process, DockerRunner, EventEmitter, ref$, compileServiceRoutes, DockerHelper, N, portReservation, path, ServiceRunner, waitUntil, AppRunner;
async = require('async');
red = require('chalk').red;
child_process = require('child_process');
DockerRunner = require('./docker-runner');
EventEmitter = require('events').EventEmitter;
ref$ = require('../../exosphere-shared'), compileServiceRoutes = ref$.compileServiceRoutes, DockerHelper = ref$.DockerHelper;
N = require('nitroglycerin');
portReservation = require('port-reservation');
path = require('path');
ServiceRunner = require('./service-runner');
waitUntil = require('wait').waitUntil;
AppRunner = (function(superclass){
  var prototype = extend$((import$(AppRunner, superclass).displayName = 'AppRunner', AppRunner), superclass).prototype, constructor = AppRunner;
  function AppRunner(arg$){
    this.appConfig = arg$.appConfig, this.logger = arg$.logger;
    this.shutdown = bind$(this, 'shutdown', prototype);
  }
  AppRunner.prototype.startExocom = function(done){
    var x$, this$ = this;
    x$ = portReservation;
    x$.getPort(N(function(exocomPort){
      var serviceRoutes, x$;
      this$.exocomPort = exocomPort;
      serviceRoutes = function(it){
        return it.replace(/"/g, '');
      }(
      JSON.stringify(
      compileServiceRoutes(this$.appConfig)));
      this$.dockerConfig = {
        author: 'originate',
        image: this$.appConfig.bus.type,
        version: this$.appConfig.bus.version,
        appName: this$.appConfig.name,
        startCommand: 'bin/exocom',
        startText: 'ExoCom WebSocket listener online at port',
        env: {
          SERVICE_ROUTES: serviceRoutes,
          PORT: this$.exocomPort,
          ROLE: 'exocom'
        },
        publish: {
          EXOCOM_PORT: this$.exocomPort + ":" + this$.exocomPort
        }
      };
      x$ = this$.exocom = new DockerRunner({
        role: 'exocom',
        dockerConfig: this$.dockerConfig,
        logger: this$.logger
      });
      x$.startService();
      x$.on('error', function(message){
        return this$.shutdown({
          errorMessage: message
        });
      });
      return x$;
    }));
    return x$;
  };
  AppRunner.prototype.startServices = function(){
    var this$ = this;
    return waitUntil(function(){
      return this$.exocomPort;
    }, 1, function(){
      var protectionLevel, role, ref$, serviceData, i$, len$, service, x$, _, runner;
      this$.services = [];
      for (protectionLevel in this$.appConfig.services) {
        for (role in ref$ = this$.appConfig.services[protectionLevel]) {
          serviceData = ref$[role];
          this$.services.push({
            role: role,
            location: serviceData.location,
            image: serviceData.docker_image
          });
        }
      }
      this$.runners = {};
      for (i$ = 0, len$ = (ref$ = this$.services).length; i$ < len$; ++i$) {
        service = ref$[i$];
        x$ = this$.runners[service.role] = new ServiceRunner({
          role: service.role,
          config: {
            root: path.join(process.cwd(), service.location),
            EXOCOM_PORT: this$.exocomPort,
            image: service.image,
            appName: this$.appConfig.name
          },
          logger: this$.logger
        });
        x$.on('error', this$.shutdown);
      }
      return async.parallel((function(){
        var ref$, results$ = [];
        for (_ in ref$ = this.runners) {
          runner = ref$[_];
          results$.push(runner.start);
        }
        return results$;
      }.call(this$)), function(err){
        return this$.logger.log({
          role: 'exo-run',
          text: 'all services online'
        });
      });
    });
  };
  AppRunner.prototype.shutdown = function(arg$){
    var closeMessage, errorMessage, exitCode, i$, ref$, len$, service;
    closeMessage = arg$.closeMessage, errorMessage = arg$.errorMessage;
    switch (false) {
    case !errorMessage:
      console.log(red(errorMessage));
      exitCode = 1;
      break;
    default:
      console.log("\n\n " + closeMessage);
      exitCode = 0;
    }
    DockerHelper.removeContainer('exocom');
    for (i$ = 0, len$ = (ref$ = this.services).length; i$ < len$; ++i$) {
      service = ref$[i$];
      DockerHelper.removeContainer(service.role);
      this.runners[service.role].shutdownDependencies();
    }
    return process.exit(exitCode);
  };
  return AppRunner;
}(EventEmitter));
module.exports = AppRunner;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}