// Generated by LiveScript 1.5.0
var async, red, DockerSetup, EventEmitter, ExocomSetup, path, ServiceSetup, AppSetup;
async = require('async');
red = require('chalk').red;
DockerSetup = require('./docker-setup');
EventEmitter = require('events').EventEmitter;
ExocomSetup = require('./exocom-setup');
path = require('path');
ServiceSetup = require('./service-setup');
AppSetup = (function(superclass){
  var prototype = extend$((import$(AppSetup, superclass).displayName = 'AppSetup', AppSetup), superclass).prototype, constructor = AppSetup;
  function AppSetup(arg$){
    this.appConfig = arg$.appConfig, this.logger = arg$.logger;
  }
  AppSetup.prototype.startSetup = function(){
    var protectionLevel, serviceRole, ref$, serviceData, setups, res$, i$, len$, service, x$, y$, this$ = this;
    this.services = [];
    for (protectionLevel in this.appConfig.services) {
      for (serviceRole in ref$ = this.appConfig.services[protectionLevel]) {
        serviceData = ref$[serviceRole];
        this.services.push({
          role: serviceRole,
          location: serviceData.location,
          dockerImage: serviceData.docker_image
        });
      }
    }
    res$ = [];
    for (i$ = 0, len$ = (ref$ = this.services).length; i$ < len$; ++i$) {
      service = ref$[i$];
      if (service.location) {
        x$ = new ServiceSetup({
          role: service.role,
          logger: this.logger,
          config: {
            root: path.join(process.cwd(), service.location)
          }
        });
        x$.on('output', fn$);
        res$.push(x$);
      }
    }
    setups = res$;
    async.mapSeries(setups, function(){
      return arguments[0].start(arguments[1]);
    }, function(err){
      var dockerSetups, res$, i$, ref$, len$, service, operation;
      switch (false) {
      case !err:
        throw new Error(err);
      }
      res$ = [];
      for (i$ = 0, len$ = (ref$ = this$.services).length; i$ < len$; ++i$) {
        service = ref$[i$];
        res$.push(new DockerSetup({
          role: service.role,
          logger: this$.logger,
          config: {
            root: service.location ? path.join(process.cwd(), service.location) : void 8,
            dockerImage: service.dockerImage
          }
        }));
      }
      dockerSetups = res$;
      operation = process.platform === 'win32'
        ? async.mapSeries
        : async.map;
      return operation(dockerSetups, function(){
        return arguments[0].start(arguments[1]);
      }, function(err){
        switch (false) {
        case !err:
          throw new Error(err);
        }
        return this$.logger.log({
          role: 'exo-setup',
          text: 'setup complete'
        });
      });
    });
    y$ = new ExocomSetup(this.appConfig, this.logger);
    y$.start();
    return y$;
    function fn$(data){
      return this$.emit('output', data);
    }
  };
  return AppSetup;
}(EventEmitter));
module.exports = AppSetup;
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}