// Generated by LiveScript 1.5.0
var red, child_process, dashify, EventEmitter, ref$, templatesPath, callArgs, DockerHelper, fs, yaml, ObservableProcess, path, cp, DockerSetup;
red = require('chalk').red;
child_process = require('child_process');
dashify = require('dashify');
EventEmitter = require('events').EventEmitter;
ref$ = require('../../exosphere-shared'), templatesPath = ref$.templatesPath, callArgs = ref$.callArgs, DockerHelper = ref$.DockerHelper;
fs = require('fs');
yaml = require('js-yaml');
ObservableProcess = require('observable-process');
path = require('path');
cp = require('shelljs').cp;
DockerSetup = (function(superclass){
  var prototype = extend$((import$(DockerSetup, superclass).displayName = 'DockerSetup', DockerSetup), superclass).prototype, constructor = DockerSetup;
  function DockerSetup(arg$){
    this.role = arg$.role, this.logger = arg$.logger, this.config = arg$.config;
    this.write = bind$(this, 'write', prototype);
    this._setupExternalService = bind$(this, '_setupExternalService', prototype);
    this._dockerFileExists = bind$(this, '_dockerFileExists', prototype);
    this._buildDockerImage = bind$(this, '_buildDockerImage', prototype);
    this.start = bind$(this, 'start', prototype);
    this.serviceConfig = this.config.root ? yaml.safeLoad(fs.readFileSync(path.join(this.config.root, 'service.yml'), 'utf8')) : void 8;
  }
  DockerSetup.prototype.start = function(done){
    switch (false) {
    case !!this.serviceConfig:
      return this._setupExternalService(done);
    case !!this._dockerFileExists():
      cp(path.join(templatesPath, 'docker', 'Dockerfile'), path.join(this.config.root, 'Dockerfile'));
    }
    this.logger.log({
      role: this.role,
      text: "preparing Docker image"
    });
    return this._buildDockerImage(done);
  };
  DockerSetup.prototype._buildDockerImage = function(done){
    var x$, this$ = this;
    x$ = new ObservableProcess(callArgs(DockerHelper.getBuildCommand({
      author: this.serviceConfig.author,
      name: dashify(this.serviceConfig.type)
    })), {
      cwd: this.config.root,
      stdout: {
        write: this.write
      },
      stderr: {
        write: this.write
      }
    });
    x$.on('ended', function(exitCode, killed){
      switch (false) {
      case exitCode !== 0:
        this$.logger.log({
          role: this$.role,
          text: "Docker setup finished"
        });
        break;
      default:
        this$.logger.log({
          role: this$.role,
          text: "Docker setup failed"
        });
        process.exit(exitCode);
      }
      return done();
    });
    return x$;
  };
  DockerSetup.prototype._dockerFileExists = function(){
    var e;
    try {
      return fs.existsSync(path.join(this.config.root, 'Dockerfile'));
    } catch (e$) {
      e = e$;
      return false;
    }
  };
  DockerSetup.prototype._setupExternalService = function(done){
    var image, x$, this$ = this;
    if (!this.config.dockerImage) {
      throw new Error(red("No location or docker-image specified"));
    }
    image = function(it){
      return it.split('/');
    }(
    this.config.dockerImage);
    x$ = new ObservableProcess(DockerHelper.getPullCommand({
      author: image[0],
      name: image[1]
    }), {
      stdout: {
        write: this.write
      },
      stderr: {
        write: this.write
      }
    });
    x$.on('ended', function(exitCode){
      switch (false) {
      case exitCode === 0:
        this$.logger.log({
          role: this$.role,
          text: 'Docker setup failed'
        });
        return process.exit(exitCode);
      default:
        return done();
      }
    });
    return x$;
  };
  DockerSetup.prototype.write = function(text){
    return this.logger.log({
      role: this.role,
      text: text,
      trim: true
    });
  };
  return DockerSetup;
}(EventEmitter));
module.exports = DockerSetup;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}