// Generated by LiveScript 1.5.0
var child_process, EventEmitter, DockerHelper, ObservableProcess, ExocomSetup;
child_process = require('child_process');
EventEmitter = require('events').EventEmitter;
DockerHelper = require('../../exosphere-shared').DockerHelper;
ObservableProcess = require('observable-process');
ExocomSetup = (function(superclass){
  var prototype = extend$((import$(ExocomSetup, superclass).displayName = 'ExocomSetup', ExocomSetup), superclass).prototype, constructor = ExocomSetup;
  function ExocomSetup(appConfig, logger){
    this.appConfig = appConfig;
    this.logger = logger;
    this.write = bind$(this, 'write', prototype);
    this.start = bind$(this, 'start', prototype);
    this.name = 'exocom';
  }
  ExocomSetup.prototype.start = function(){
    var version, x$, this$ = this;
    version = this.appConfig.bus.version;
    if (DockerHelper.imageExists({
      author: 'originate',
      name: 'exocom',
      version: version
    })) {
      this.logger.log({
        role: this.name,
        text: 'ExoCom image already up to date'
      });
      return;
    }
    this.logger.log({
      role: this.name,
      text: "Pulling ExoCom image version " + version
    });
    x$ = new ObservableProcess(DockerHelper.getPullCommand({
      author: 'originate',
      name: 'exocom',
      version: version
    }), {
      stdout: {
        write: this.write
      },
      stderr: {
        write: this.write
      }
    });
    x$.on('ended', function(exitCode){
      switch (false) {
      case exitCode !== 0:
        return this$.logger.log({
          role: this$.name,
          text: "ExoCom image updated to version " + version
        });
      default:
        return this$.logger.log({
          role: this$.name,
          text: "Failed to retrieve latest ExoCom image"
        });
      }
    });
    return x$;
  };
  ExocomSetup.prototype.write = function(text){
    return this.logger.log({
      role: this.name,
      text: text,
      trim: true
    });
  };
  return ExocomSetup;
}(EventEmitter));
module.exports = ExocomSetup;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}