// Generated by LiveScript 1.5.0
var async, EventEmitter, path, filter, ServiceTester, AppTester;
async = require('async');
EventEmitter = require('events').EventEmitter;
path = require('path');
filter = require('prelude-ls').filter;
ServiceTester = require('./service-tester');
AppTester = (function(superclass){
  var prototype = extend$((import$(AppTester, superclass).displayName = 'AppTester', AppTester), superclass).prototype, constructor = AppTester;
  function AppTester(arg$){
    this.appConfig = arg$.appConfig, this.logger = arg$.logger;
  }
  AppTester.prototype.startTesting = function(){
    var testers, protectionLevel, serviceRole, ref$, serviceData, serviceDir, tester, this$ = this;
    testers = [];
    for (protectionLevel in this.appConfig.services) {
      for (serviceRole in ref$ = this.appConfig.services[protectionLevel]) {
        serviceData = ref$[serviceRole];
        serviceDir = path.join(process.cwd(), serviceData.location);
        testers.push(new ServiceTester({
          role: serviceRole,
          config: {
            root: serviceDir
          },
          logger: this.logger
        }));
      }
    }
    return async.series((function(){
      var i$, ref$, len$, results$ = [];
      for (i$ = 0, len$ = (ref$ = testers).length; i$ < len$; ++i$) {
        tester = ref$[i$];
        results$.push(tester.start);
      }
      return results$;
    }()), function(err, exitCodes){
      switch (false) {
      case !err:
        this$.logger.log({
          role: 'exo-test',
          text: 'Tests failed'
        });
        return process.exit(1);
      case !this$._containsNonZero(exitCodes):
        this$.logger.log({
          role: 'exo-test',
          text: 'Tests failed'
        });
        return process.exit(1);
      default:
        return this$.logger.log({
          role: 'exo-test',
          text: 'All tests passed'
        });
      }
    });
  };
  AppTester.prototype._containsNonZero = function(exitCodes){
    var this$ = this;
    return exitCodes.filter((function(it){
      return it > 0;
    })).length > 0;
  };
  return AppTester;
}(EventEmitter));
module.exports = AppTester;
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}