// Generated by LiveScript 1.5.0
var AppTester, ref$, cyan, green, red, fs, yaml, Logger, path, flatten, ServiceTester;
AppTester = require('./app-tester');
ref$ = require('chalk'), cyan = ref$.cyan, green = ref$.green, red = ref$.red;
fs = require('fs');
yaml = require('js-yaml');
Logger = require('../../exosphere-shared').Logger;
path = require('path');
flatten = require('prelude-ls').flatten;
ServiceTester = require('./service-tester');
module.exports = function(){
  var logger;
  switch (false) {
  case !cwdIsService():
    return testService();
  case !cwdIsApp():
    return testApp();
  default:
    return logger = new Logger().log({
      role: 'exo-test',
      text: "Tests do not exist. Not in service or application directory."
    });
  }
};
function cwdIsService(){
  var e;
  try {
    return fs.statSync('service.yml');
  } catch (e$) {
    e = e$;
    return false;
  }
}
function cwdIsApp(){
  var e;
  try {
    return fs.statSync('application.yml');
  } catch (e$) {
    e = e$;
    return false;
  }
}
function testService(){
  var serviceRole, x$, logger, y$, this$ = this;
  serviceRole = path.basename(process.cwd());
  x$ = logger = new Logger([serviceRole]);
  x$.log({
    role: 'exo-test',
    text: "Testing service '" + serviceRole + "'"
  });
  y$ = new ServiceTester({
    role: serviceRole,
    config: {
      root: process.cwd()
    },
    logger: logger
  });
  y$.start(function(){
    return y$.removeDependencies();
  });
  return y$;
}
function testApp(){
  var appConfig, x$, logger, protectionLevel, y$, appTester;
  appConfig = yaml.safeLoad(fs.readFileSync('application.yml', 'utf8'));
  x$ = logger = new Logger(flatten((function(){
    var results$ = [];
    for (protectionLevel in appConfig.services) {
      results$.push(Object.keys(appConfig.services[protectionLevel]));
    }
    return results$;
  }())));
  x$.log({
    role: 'exo-test',
    text: "Testing application '" + appConfig.name + "'"
  });
  y$ = appTester = new AppTester({
    appConfig: appConfig,
    logger: logger
  });
  y$.startTesting();
  return y$;
}