// Generated by LiveScript 1.5.0
var child_process, DockerHelper;
child_process = require('child_process');
DockerHelper = (function(){
  DockerHelper.displayName = 'DockerHelper';
  var prototype = DockerHelper.prototype, constructor = DockerHelper;
  DockerHelper.containerExists = function(container){
    var this$ = this;
    return function(it){
      return it.includes(container);
    }(
    function(it){
      return it.split('\n');
    }(
    function(it){
      return it.toString();
    }(
    child_process.execSync('docker ps -a --format {{.Names}}'))));
  };
  DockerHelper.containerIsRunning = function(containerName){
    var this$ = this;
    return function(it){
      return it.includes(containerName + "/Up");
    }(
    function(it){
      return it.split('\n');
    }(
    function(it){
      return it.toString();
    }(
    child_process.execSync('docker ps --format {{.Names}}/{{.Status}}'))));
  };
  DockerHelper.ensureContainerIsRunning = function(containerName, image){
    switch (false) {
    case !this.containerIsRunning(containerName):
      break;
    case !this.containerExists(containerName):
      return this.startContainer(containerName);
    default:
      return this.runImage(containerName, image);
    }
  };
  DockerHelper.getBuildCommand = function(image, buildFlags){
    return "docker build -t " + image.author + "/" + image.name + " " + (buildFlags ? buildFlags : "") + " .";
  };
  DockerHelper.getConfig = function(image){
    var this$ = this;
    return function(it){
      return it.toString();
    }(
    child_process.execSync("docker run --rm=true " + image + " cat service.yml", 'utf8'));
  };
  DockerHelper.getDockerIp = function(container){
    if (this.containerExists(container)) {
      return child_process.execSync("docker inspect --format '{{ .NetworkSettings.IPAddress }}' " + container, "utf8");
    }
  };
  DockerHelper.getDockerImages = function(){
    return child_process.execSync('docker images');
  };
  DockerHelper.getPullCommand = function(image){
    return "docker pull " + image.author + "/" + image.name + (image.version ? ":" + image.version : "");
  };
  DockerHelper.removeContainer = function(container){
    if (this.containerExists(container)) {
      return child_process.execSync("docker rm -f " + container);
    }
  };
  DockerHelper.runImage = function(container, image){
    if (container === 'test-mongo') {
      return child_process.execSync("docker run -d --name=" + container + " -p 27017:27017 " + image);
    } else {
      return child_process.execSync("docker run -d --name=" + container + " " + image);
    }
  };
  DockerHelper.startContainer = function(containerName){
    if (this.containerExists(containerName)) {
      return child_process.execSync("docker start " + containerName);
    }
  };
  DockerHelper.imageExists = function(image){
    var this$ = this;
    return function(it){
      return it.includes(image.author + "/" + image.name);
    }(
    child_process.execSync("docker images " + image.author + "/" + image.name + (image.version ? ":" + image.version : ""), "utf-8"));
  };
  DockerHelper.removeAllContainers = function(){
    var allContainers, this$ = this;
    allContainers = function(it){
      return it.toString();
    }(
    child_process.execSync('docker ps -aq'));
    if (allContainers) {
      return child_process.execSync('docker rm -f $(docker ps -aq)');
    }
  };
  function DockerHelper(){}
  return DockerHelper;
}());
module.exports = DockerHelper;