// Generated by LiveScript 1.5.0
var ref$, black, blue, bold, cyan, dim, green, magenta, red, reset, white, yellow, map, maximum, Logger;
ref$ = require('chalk'), black = ref$.black, blue = ref$.blue, bold = ref$.bold, cyan = ref$.cyan, dim = ref$.dim, green = ref$.green, magenta = ref$.magenta, red = ref$.red, reset = ref$.reset, white = ref$.white, yellow = ref$.yellow;
ref$ = require('prelude-ls'), map = ref$.map, maximum = ref$.maximum;
Logger = (function(){
  Logger.displayName = 'Logger';
  var prototype = Logger.prototype, constructor = Logger;
  function Logger(roles){
    roles == null && (roles = []);
    this.error = bind$(this, 'error', prototype);
    this.log = bind$(this, 'log', prototype);
    this.colors = {
      exocom: blue,
      exorun: reset,
      'exo-clone': reset,
      'exo-setup': reset,
      'exo-test': reset,
      'exo-sync': reset,
      'exo-lint': reset,
      'exo-deploy': reset
    };
    this.setColors(roles);
  }
  Logger.prototype.log = function(arg$){
    var role, text, trim, color, ref$, i$, len$, line, results$ = [];
    role = arg$.role, text = arg$.text, trim = arg$.trim;
    color = (ref$ = this.colors[role]) != null ? ref$ : reset;
    if (trim) {
      text = text.trim();
    }
    for (i$ = 0, len$ = (ref$ = text.split('\n')).length; i$ < len$; ++i$) {
      line = ref$[i$];
      results$.push(console.log(color(bold(this._pad(role) + " ")), color(line)));
    }
    return results$;
  };
  Logger.prototype.error = function(arg$){
    var role, text, trim, color, ref$, i$, len$, line, results$ = [];
    role = arg$.role, text = arg$.text, trim = arg$.trim;
    color = (ref$ = this.colors[role]) != null ? ref$ : reset;
    if (trim) {
      text = text.trim();
    }
    for (i$ = 0, len$ = (ref$ = text.split('\n')).length; i$ < len$; ++i$) {
      line = ref$[i$];
      results$.push(console.error(color(bold(this._pad(role) + " ")), red(line)));
    }
    return results$;
  };
  Logger.prototype.setColors = function(roles){
    var i$, len$, i, role, this$ = this;
    for (i$ = 0, len$ = roles.length; i$ < len$; ++i$) {
      i = i$;
      role = roles[i$];
      this.colors[role] = Logger._default_colors[i % Logger._default_colors.length];
    }
    return this.length = maximum(
    map(function(it){
      return it.length;
    }, Object.keys(this.colors)));
  };
  Logger._default_colors = [blue, cyan, magenta, yellow];
  Logger.prototype._pad = function(text){
    return ("               " + text).slice(-this.length);
  };
  return Logger;
}());
module.exports = Logger;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}